# Rhye's and Fall of Civilization - Main Scenario

from CvPythonExtensions import *
import CvUtil
import PyHelpers        # LOQ
import Popup
import pickle        	# LOQ 2005-10-12
import CvTranslator
import RFCUtils
import Consts as con




################
### Globals ###
##############

gc = CyGlobalContext()	# LOQ
PyPlayer = PyHelpers.PyPlayer	# LOQ
utils = RFCUtils.RFCUtils()

iCheatersPeriod = 10
iBetrayalPeriod = 8
iBetrayalThreshold = 66
iRebellionDelay = 15
iEscapePeriod = 30
tAIStopBirthThreshold = (80, 80, 60, 80, 70, 80, 80, 80, 60, 60, 50, 70, 70, 70, 70, 70, 70, 50)

iSettler = con.iSettler
iWarrior = con.iWarrior
iScout = con.iScout


# initialise player variables

iEgypt = con.iEgypt
iIndia = con.iIndia
iChina = con.iChina
iGreece = con.iGreece
iPersia = con.iPersia
iRome = con.iRome
iJapan = con.iJapan
iArabia = con.iArabia
iSpain = con.iSpain
iFrance = con.iFrance
iEngland = con.iEngland
iGermany = con.iGermany
iRussia = con.iRussia
iMali = con.iMali
iInca = con.iInca
iMongolia = con.iMongolia
iAztecs = con.iAztecs
iAmerica = con.iAmerica
iNumPlayers = con.iNumPlayers
iBarbarian = con.iBarbarian

pEgypt = gc.getPlayer(iEgypt)
pIndia = gc.getPlayer(iIndia)
pChina = gc.getPlayer(iChina)
pGreece = gc.getPlayer(iGreece)
pPersia = gc.getPlayer(iPersia)
pRome = gc.getPlayer(iRome)
pJapan = gc.getPlayer(iJapan)
pArabia = gc.getPlayer(iArabia)
pSpain = gc.getPlayer(iSpain)
pFrance = gc.getPlayer(iFrance)
pEngland = gc.getPlayer(iEngland)
pGermany = gc.getPlayer(iGermany)
pRussia = gc.getPlayer(iRussia)
pMali = gc.getPlayer(iMali)
pInca = gc.getPlayer(iInca)
pMongolia = gc.getPlayer(iMongolia)
pAztecs = gc.getPlayer(iAztecs)
pAmerica = gc.getPlayer(iAmerica)
pBarbarian = gc.getPlayer(iBarbarian)

teamEgypt = gc.getTeam(pEgypt.getTeam())
teamIndia = gc.getTeam(pIndia.getTeam())
teamChina = gc.getTeam(pChina.getTeam())
teamGreece = gc.getTeam(pGreece.getTeam())
teamPersia = gc.getTeam(pPersia.getTeam())
teamRome = gc.getTeam(pRome.getTeam())
teamJapan = gc.getTeam(pJapan.getTeam())
teamArabia = gc.getTeam(pArabia.getTeam())
teamSpain = gc.getTeam(pSpain.getTeam())
teamFrance = gc.getTeam(pFrance.getTeam())
teamEngland = gc.getTeam(pEngland.getTeam())
teamGermany = gc.getTeam(pGermany.getTeam())
teamRussia = gc.getTeam(pRussia.getTeam())
teamMali = gc.getTeam(pMali.getTeam())
teamInca = gc.getTeam(pInca.getTeam())
teamMongolia = gc.getTeam(pMongolia.getTeam())
teamAztecs = gc.getTeam(pAztecs.getTeam())
teamAmerica = gc.getTeam(pAmerica.getTeam())
teamBarbarian = gc.getTeam(pBarbarian.getTeam())


#for not allowing new civ popup if too close
tDifference = (0, 0, 0, 2, 2, 1, 0, 5, 4, 3, 2, 1, 0, 1, 2, 1, 0, 0)
                    


# starting locations coordinates
tCapitals = (
(69, 33), #tThebes
(90, 40), #tDelhi
(102, 47), #tBeijing
(67, 41), #tAthens
(82, 39), #tPersepolis
(60, 44), #tRome
(113, 45), #tKyoto
(75, 33), #tMecca
(52, 43), #tMadrid
(55, 50), #tParis
(53, 54), #tLondon
(62, 52), #tBerlin
(73, 54), #tMoskow
(53, 31), #tTimbuktu
(28, 22), #tCuzco
(99, 51), #tKarakorum
(18, 37), #tTenochtitlan
(27, 46)) #tWashington



# core areas coordinates (top left and bottom right)

tCoreAreasTL = con.tCoreAreasTL

tCoreAreasBR = con.tCoreAreasBR


tExceptions = (
(), #Egypt
(), #India
(), #China
(), #Greece
(), #Persia
(), #Rome
(), #Japan
((73, 40), (74, 40), (75, 40), (76, 40), (77, 40), (71, 36), (72, 37)),  #Arabia
(), #Spain
((56, 46), (57, 46)), #France
(), #England
((62, 47), (63, 47), (64, 47)),  #Germany
((68, 56), (68, 57), (68, 58)), #Russia
(), #Mali
(), #Inca
(), #Mongolia
(), #Aztecs
((29, 49), (30, 49), (31, 49), (30, 50), (31, 50), (32, 50), (24, 44), (25, 44), (24, 43), (25, 43))) #America

# broader areas coordinates (top left and bottom right)

tBroaderAreasTL = (
(60, 26), #Egypt
(85, 28), #India
(95, 38), #China
(62, 39), #Greece
(70, 37), #Persia
(49, 35), #Rome
(110, 40), #Japan
(64, 30), #Arabia
(49, 38), #Spain
(49, 44), #France
(48, 53), #England
(55, 46), #Germany
(65, 48), #Russia
(48, 21), #Mali
(24, 14), #Inca
(82, 44), #Mongolia
(14, 32), #Aztecs
(10, 42)) #America

tBroaderAreasBR = (
(74, 38), #Egypt
(99, 43), #India
(107, 50), #China
(77, 47), #Greece
(87, 49), #Persia
(73, 50), #Rome
(116, 56), #Japan
(85, 44), #Arabia
(55, 46), #Spain
(61, 52), #France
(54, 60), #England
(67, 56), #Germany
(92, 59), #Russia
(67, 32), #Mali
(30, 27), #Inca
(110, 62), #Mongolia
(24, 43), #Aztecs
(37, 56)) #America




class RiseAndFall:


##################################################
### Secure storage & retrieval of script data ###
################################################
        

        def getNewCiv( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iNewCiv']

        def setNewCiv( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iNewCiv'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )        

        def getNewCivFlip( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iNewCivFlip']

        def setNewCivFlip( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iNewCivFlip'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )      
        
        def getTempTopLeft( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempTopLeft']

        def setTempTopLeft( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempTopLeft'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getTempBottomRight( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempBottomRight']

        def setTempBottomRight( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempBottomRight'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getSpawnWar( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iSpawnWar']

        def setSpawnWar( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iSpawnWar'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getAlreadySwitched( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['bAlreadySwitched']

        def setAlreadySwitched( self, bNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['bAlreadySwitched'] = bNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getColonistsAlreadyGiven( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lColonistsAlreadyGiven'][iCiv]

        def setColonistsAlreadyGiven( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lColonistsAlreadyGiven'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getNumCities( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lNumCities'][iCiv]

        def setNumCities( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lNumCities'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getSpawnDelay( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lSpawnDelay'][iCiv]

        def setSpawnDelay( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lSpawnDelay'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getFlipsDelay( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lFlipsDelay'][iCiv]

        def setFlipsDelay( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lFlipsDelay'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getBetrayalTurns( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iBetrayalTurns']

        def setBetrayalTurns( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iBetrayalTurns'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )  

        def getLatestFlipTurn( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iLatestFlipTurn']

        def setLatestFlipTurn( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iLatestFlipTurn'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getLatestRebellionTurn( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lLatestRebellionTurn'][iCiv]

        def setLatestRebellionTurn( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lLatestRebellionTurn'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getRebelCiv( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['iRebelCiv']

        def setRebelCiv( self, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['iRebelCiv'] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )
                
        def getExileData( self, i ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lExileData'][i]

        def setExileData( self, i, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lExileData'][i] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )
        
        def getTempFlippingCity( self ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['tempFlippingCity']

        def setTempFlippingCity( self, tNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['tempFlippingCity'] = tNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) ) 

        def getCheatersCheck( self, i ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lCheatersCheck'][i]

        def setCheatersCheck( self, i, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lCheatersCheck'][i] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )

        def getBirthTurnModifier( self, iCiv ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                return scriptDict['lBirthTurnModifier'][iCiv]

        def setBirthTurnModifier( self, iCiv, iNewValue ):
                scriptDict = pickle.loads( gc.getGame().getScriptData() )
                scriptDict['lBirthTurnModifier'][iCiv] = iNewValue
                gc.getGame().setScriptData( pickle.dumps(scriptDict) )   



                
###############
### Popups ###
#############

        ''' popupID has to be a registered ID in CvRhyesCatapultEventManager.__init__!! '''
        def showPopup(self, popupID, title, message, labels):
                popup = Popup.PyPopup(popupID, EventContextTypes.EVENTCONTEXT_ALL)
                popup.setHeaderString(title)
                popup.setBodyString(message)
                for i in labels:
                    popup.addButton( i )
                popup.launch(False)


        def newCivPopup(self, strText, iCiv):
                self.showPopup(7614, CyTranslator().getText("TXT_KEY_NEWCIV_TITLE", ()), CyTranslator().getText("TXT_KEY_NEWCIV_MESSAGE1", ()) + " " + strText + " " + CyTranslator().getText("TXT_KEY_NEWCIV_MESSAGE2", ()), (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                self.setNewCiv(iCiv)

        def eventApply7614(self, popupReturn):
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        gc.getGame().setActivePlayer(self.getNewCiv(), False)
                        self.setAlreadySwitched(True)
                        #CyInterface().addImmediateMessage("first button", "")
                #elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        #CyInterface().addImmediateMessage("second button", "")


        def flipPopup(self, iNewCiv, tTopLeft, tBottomRight):
                iHuman = utils.getHumanID()
                flipText = CyTranslator().getText("TXT_KEY_FLIPMESSAGE1", ())
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() == iHuman):
                                                if (not pCurrent.getPlotCity().isCapital()):
                                                        flipText += (pCurrent.getPlotCity().getName() + "\n")
                #exceptions
                if (len(tExceptions[iNewCiv])):
                        for j in range(len(tExceptions[iNewCiv])):
                                pCurrent = gc.getMap().plot( tExceptions[self.getNewCivFlip()][j][0], tExceptions[self.getNewCivFlip()][j][1] )
                                if (pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() == iHuman):
                                                if (not pCurrent.getPlotCity().isCapital()):
                                                        flipText += (pCurrent.getPlotCity().getName() + "\n")                                                
                flipText += CyTranslator().getText("TXT_KEY_FLIPMESSAGE2", ())
                                                        
                self.showPopup(7615, CyTranslator().getText("TXT_KEY_NEWCIV_TITLE", ()), flipText, (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                self.setNewCivFlip(iNewCiv)
                self.setTempTopLeft(tTopLeft)
                self.setTempBottomRight(tBottomRight)

        def eventApply7615(self, popupReturn):
                iHuman = utils.getHumanID()
                tTopLeft = self.getTempTopLeft()
                tBottomRight = self.getTempBottomRight()

                humanCityList = []
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        city = pCurrent.getPlotCity()
                                        if (city.getOwner() == iHuman):
                                                if (not city.isCapital()):
                                                        humanCityList.append(city)
                #exceptions
                if (len(tExceptions[self.getNewCivFlip()])):
                        for j in range(len(tExceptions[self.getNewCivFlip()])):
                                pCurrent = gc.getMap().plot( tExceptions[self.getNewCivFlip()][j][0], tExceptions[self.getNewCivFlip()][j][1] )
                                if (pCurrent.isCity()):
                                        city = pCurrent.getPlotCity()
                                        if (city.getOwner() == iHuman):
                                                if (not city.isCapital()):
                                                        humanCityList.append(city)
                
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        print ("Flip agreed")
                        CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_AGREED", ()), "")
                                                
                        if (len(humanCityList)):
                                for i in range(len(humanCityList)):
                                        city = humanCityList[i]
                                        print ("flipping ", city.getName())
                                        utils.cultureManager((city.getX(),city.getY()), 100, self.getNewCivFlip(), iHuman, False, False, False)
                                        utils.flipUnitsInCityBefore((city.getX(),city.getY()), self.getNewCivFlip(), iHuman)
                                        self.setTempFlippingCity((city.getX(),city.getY()))
                                        utils.flipCity((city.getX(), city.getY()), 0, 0, self.getNewCivFlip(), [iHuman])                                        
                                        utils.flipUnitsInCityAfter(self.getTempFlippingCity(), self.getNewCivFlip())

                        if (self.getCheatersCheck(0) == 0):
                                self.setCheatersCheck(0, iCheatersPeriod)
                                self.setCheatersCheck(1, self.getNewCivFlip())
                                
                elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        print ("Flip disagreed")

                        if (len(humanCityList)):
                                for i in range(len(humanCityList)):
                                        city = humanCityList[i]
                                        city.setCulture(self.getNewCivFlip(), city.countTotalCulture(), True)
                                        iWar = self.getSpawnWar() + 1
                                        self.setSpawnWar(iWar)
                                        if (self.getSpawnWar() == 1):
                                                CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_REFUSED", ()), "")
                                                gc.getTeam(gc.getPlayer(self.getNewCivFlip()).getTeam()).declareWar(iHuman, False) ##True??
                                                self.setBetrayalTurns(iBetrayalPeriod)
                                                self.initBetrayal()


                                        
                                                                
                                
        def rebellionPopup(self, iRebelCiv):
                self.showPopup(7622, CyTranslator().getText("TXT_KEY_REBELLION_TITLE", ()),CyTranslator().getText("TXT_KEY_INDEPENDENCE1", ()) + " " + gc.getPlayer(iRebelCiv).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_REBELLION_MESSAGE", ()), (CyTranslator().getText("TXT_KEY_POPUP_YES", ()), CyTranslator().getText("TXT_KEY_POPUP_NO", ())))
                

        def eventApply7622(self, popupReturn):
                iHuman = utils.getHumanID()
                iRebelCiv = self.getRebelCiv()
                if( popupReturn.getButtonClicked() == 0 ): # 1st button
                        gc.getTeam(gc.getPlayer(iHuman).getTeam()).makePeace(iRebelCiv)                                                   
                elif( popupReturn.getButtonClicked() == 1 ): # 2nd button
                        gc.getTeam(gc.getPlayer(iHuman).getTeam()).declareWar(iRebelCiv, False)



#######################################
### Main methods (Event-Triggered) ###
#####################################  

        def setup(self):            

                #self.setupBirthTurnModifiers() (causes a crash on civ switch)
                
                self.create4000BCstartingUnits()
                #self.assign4000BCtechs()
                               
                # set starting gold
                pGreece.changeGold(100)
                pRome.changeGold(100)
                pPersia.changeGold(200)
                pJapan.changeGold(100)
                pMongolia.changeGold(200)
                pFrance.changeGold(150)
                pArabia.changeGold(300)
                pSpain.changeGold(200)
                pEngland.changeGold(200)
                pGermany.changeGold(150)
                pRussia.changeGold(200)
                pMali.changeGold(800)
                pInca.changeGold(700)
                pAztecs.changeGold(700)
                pAmerica.changeGold(1500)
               
           
                # display welcome message
                #self.displayWelcomePopup()

                #center camera on Egyptian units
                if (pEgypt.isHuman()):
                        plotEgypt = gc.getMap().plot(tCapitals[iEgypt][0], tCapitals[iEgypt][1])   
                        unit = plotEgypt.getUnit(0)
                        unit.centerCamera()
                        #print (unit)


        def setupBirthTurnModifiers(self):
                for iCiv in range(iNumPlayers):
                        if (iCiv >= iGreece and not gc.getPlayer(iCiv).isHuman()):
                                self.setBirthTurnModifier(iCiv, (gc.getGame().getSorenRandNum(11, 'BirthTurnModifier') - 5)) # -5 to +5
                #now make sure that no civs spawn in the same turn and cause a double "new civ" popup
                for iCiv in range(iNumPlayers):
                        if (iCiv > utils.getHumanID() and iCiv < iAmerica):
                                for j in range(iNumPlayers-1-iCiv):
                                        iNextCiv = iCiv+j+1
                                        if (con.tBirth[iCiv]+self.getBirthTurnModifier(iCiv) == con.tBirth[iNextCiv]+self.getBirthTurnModifier(iNextCiv)):
                                                self.setBirthTurnModifier(iNextCiv, (self.getBirthTurnModifier(iNextCiv)+1))

        	
        def checkTurn(self, iGameTurn):

                #debug
                print ("iGameTurn", iGameTurn)
                
                #pEgypt.changeGold(200)
                #teamEgypt.changeResearchProgress(con.iNationalism, 3299, iEgypt)

                #invasion attempt
                #if (iGameTurn == 100):
                #        utils.makeUnit(iAxeman, iGermany, tCapitals[iGermany], 3)
                #        utils.makeUnit(iSwordsman, iGermany, tCapitals[iGermany], 3)
                
                #for iCiv in range(iNumPlayers):
                #        for pyCity in PyPlayer(iCiv).getCityList():
                #                print (pyCity.GetCy().getName())
                
                #for iCiv in range(iNumPlayers):
                #        print (iCiv, self.getBirthTurnModifier(iCiv))
                #self.setBirthTurnModifier(iGreece, 0)

                #print ("TOTAL", pEgypt.countTotalCulture())

                
                
                #Trigger betrayal mode
                if (self.getBetrayalTurns() > 0):
                        self.initBetrayal()

                if (self.getCheatersCheck(0) > 0):
                        teamPlayer = gc.getTeam(gc.getPlayer(utils.getHumanID()).getTeam())
                        if (teamPlayer.isAtWar(self.getCheatersCheck(1))):
                                print ("No cheaters!")
                                self.initMinorBetrayal(self.getCheatersCheck(1))
                                self.setCheatersCheck(0, 0)
                                self.setCheatersCheck(1, -1)
                        else:
                                self.setCheatersCheck(0, self.getCheatersCheck(0)-1)

                #Colonists
                if (iGameTurn >= (con.i1400AD + self.getColonistsAlreadyGiven(iSpain)*10)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iSpain, tBroaderAreasTL[iSpain], tBroaderAreasBR[iSpain])
                if (iGameTurn >= (con.i1500AD + self.getColonistsAlreadyGiven(iEngland)*10)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iEngland, tBroaderAreasTL[iEngland], tBroaderAreasBR[iEngland])
                if (iGameTurn >= (con.i1500AD + self.getColonistsAlreadyGiven(iFrance)*10)) and (iGameTurn <= con.i1918AD):
                        self.giveColonists(iFrance, tBroaderAreasTL[iFrance], tBroaderAreasBR[iFrance])


                #birth of civs
                self.initBirth(iGameTurn, con.tBirth[iGreece]+self.getBirthTurnModifier(iGreece), iGreece, CyTranslator().getText("TXT_KEY_CIV_GREECE_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iPersia]+self.getBirthTurnModifier(iPersia), iPersia, CyTranslator().getText("TXT_KEY_CIV_PERSIA_ADJECTIVE", ()))    
                self.initBirth(iGameTurn, con.tBirth[iRome]+self.getBirthTurnModifier(iRome), iRome, CyTranslator().getText("TXT_KEY_CIV_ROME_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iJapan]+self.getBirthTurnModifier(iJapan), iJapan, CyTranslator().getText("TXT_KEY_CIV_JAPAN_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iArabia]+self.getBirthTurnModifier(iArabia), iArabia, CyTranslator().getText("TXT_KEY_CIV_ARABIA_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iSpain]+self.getBirthTurnModifier(iSpain), iSpain, CyTranslator().getText("TXT_KEY_CIV_SPAIN_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iFrance]+self.getBirthTurnModifier(iFrance), iFrance, CyTranslator().getText("TXT_KEY_CIV_FRANCE_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iEngland]+self.getBirthTurnModifier(iEngland), iEngland, CyTranslator().getText("TXT_KEY_CIV_ENGLAND_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iGermany]+self.getBirthTurnModifier(iGermany), iGermany, CyTranslator().getText("TXT_KEY_CIV_GERMANY_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iRussia]+self.getBirthTurnModifier(iRussia), iRussia, CyTranslator().getText("TXT_KEY_CIV_RUSSIA_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iMali]+self.getBirthTurnModifier(iMali), iMali, CyTranslator().getText("TXT_KEY_CIV_MALI_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iInca]+self.getBirthTurnModifier(iInca), iInca, CyTranslator().getText("TXT_KEY_CIV_INCA_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iMongolia]+self.getBirthTurnModifier(iMongolia), iMongolia, CyTranslator().getText("TXT_KEY_CIV_MONGOL_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iAztecs]+self.getBirthTurnModifier(iAztecs), iAztecs, CyTranslator().getText("TXT_KEY_CIV_AZTEC_ADJECTIVE", ()))
                self.initBirth(iGameTurn, con.tBirth[iAmerica]+self.getBirthTurnModifier(iAmerica), iAmerica, CyTranslator().getText("TXT_KEY_CIV_AMERICA_ADJECTIVE", ()))


                #fall of civs
                if (iGameTurn >= con.i476AD and iGameTurn % 4 == 0):
                        self.collapseByBarbs(iGameTurn)                                        
                if (iGameTurn >= con.i2000BC and iGameTurn % 15 == 0):
                        self.collapseGeneric(iGameTurn)
                if (iGameTurn >= con.i2000BC and iGameTurn % 12 == 11):
                        self.collapseMotherland(iGameTurn)
                #debug
                #self.collapseMotherland()

                #resurrection of civs
                if (gc.getGame().countCivPlayersEverAlive() - gc.getGame().countCivPlayersAlive() > 3):
                        if (iGameTurn % 25 == 15):
                                self.resurrection(iGameTurn)
                if (gc.getGame().countCivPlayersEverAlive() - gc.getGame().countCivPlayersAlive() > 5):
                        if (iGameTurn % 20 == 17):
                                self.resurrectionFromBarbs(iGameTurn)
                #debug
                #self.resurrection(iGameTurn)          
                #self.resurrectionFromBarbs(iGameTurn)



        def collapseCapitals(self, iOldOwner, city, iNewOwner):
        #Persian UP inside
        #AI tweaked in CvCity::getCulturePercentAnger()
        
                bCapital = False
                bPersia = False
                iModifier = 0
                for i in range(iNumPlayers):
                        if (city.getX() == tCapitals[i][0] and city.getY() == tCapitals[i][1]):
                                if (city.getOwner() == i): #otherwise it's no longer a capital
                                        bCapital = True                                
                if (iNewOwner == iPersia):
                        bPersia = True
                        if (not bCapital):
                                iModifier = 1
                if (iNewOwner == self.getRebelCiv() and gc.getGame().getGameTurn() == self.getLatestRebellionTurn(self.getRebelCiv())):
                        return #don't mess up with resurrection()
                #print ("iNewOwner", iNewOwner, con.tBirth[iNewOwner])
                if (iNewOwner == iBarbarian):
                        return
                if (iNewOwner != iBarbarian):
                        if (gc.getGame().getGameTurn() <= con.tBirth[iNewOwner] + 2):
                                return #don't mess up with birth (case of delay still a problem...)
                if (bCapital or bPersia):
                        for x in range(city.getX() -3 +iModifier, city.getX() +4 -iModifier):
                                for y in range(city.getY() -3 +iModifier, city.getY() +4 -iModifier):
                                        pCurrent = gc.getMap().plot( x, y )
                                        if ( pCurrent.isCity()):
                                                cityNear = pCurrent.getPlotCity()
                                                iOwnerNear = cityNear.getOwner()
                                                print ("iOwnerNear", iOwnerNear, "citynear", cityNear.getName())
                                                if (iOwnerNear != iNewOwner and iOwnerNear == iOldOwner):
                                                        if (cityNear != city):
                                                                if (cityNear.getPopulation() <= city.getPopulation() and not cityNear.isCapital()):
                                                                        if (bPersia == True and iModifier == 1): #Persian UP - any city, 2x2 area
                                                                                if (cityNear.getPopulation() <= 6):
                                                                                        if (self.getLatestFlipTurn() != gc.getGame().getGameTurn()):                                                                               
                                                                                                utils.flipUnitsInCityBefore((x,y), iNewOwner, iOwnerNear)
                                                                                                self.setTempFlippingCity((x,y))
                                                                                                utils.flipCity((x,y), 0, 0, iNewOwner, [iOwnerNear])
                                                                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewOwner)
                                                                                                self.setLatestFlipTurn(gc.getGame().getGameTurn())
                                                                                                utils.cultureManager(self.getTempFlippingCity(), 50, iOwnerNear, iNewOwner, False, False, False)
                                                                                else:   
                                                                                        utils.flipUnitsInCityBefore((x,y), iNewOwner, iOwnerNear)
                                                                                        self.setTempFlippingCity((x,y))
                                                                                        utils.flipCity((x,y), 0, 0, iNewOwner, [iOwnerNear])
                                                                                        utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iNewOwner)
                                                                                        utils.cultureManager(self.getTempFlippingCity(), 50, iOwnerNear, iNewOwner, False, False, False)
                                                                                        

                            

        def collapseByBarbs(self, iGameTurn):
                for iCiv in range(iNumPlayers):
                        if (gc.getPlayer(iCiv).isHuman() == 0 and gc.getPlayer(iCiv).isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        iNumCities = gc.getPlayer(iCiv).getNumCities()
                                        iLostCities = 0
                                        for x in range(0, 124):
                                                for y in range(0, 168):
                                                        if (gc.getMap().plot( x,y ).isCity()):
                                                                city = gc.getMap().plot( x,y ).getPlotCity()
                                                                if (city.getOwner() == iBarbarian):
                                                                        if (city.getOriginalOwner() == iCiv):
                                                                                iLostCities = iLostCities + 1                                                
                                        if (iLostCities*2 > iNumCities and iNumCities > 0): #if more than one third is captured, the civ collapses
                                                print ("CollapseByBarbs", gc.getPlayer(iCiv).getCivilizationAdjective(0))
                                                self.killCiv(iCiv, iBarbarian)

        def collapseGeneric(self, iGameTurn):
                lNumCitiesNew = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
                for iCiv in range(con.iNumPlayers):
                        if (gc.getPlayer(iCiv).isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        lNumCitiesNew[iCiv] = gc.getPlayer(iCiv).getNumCities()
                                        if (lNumCitiesNew[iCiv]*2 <= self.getNumCities(iCiv)): #if number of cities is less than half than some turns ago, the civ collapses
                                                print ("CollapseGeneric", gc.getPlayer(iCiv).getCivilizationAdjective(0), lNumCitiesNew[iCiv]*2, "<=", self.getNumCities(iCiv))
                                                if (gc.getPlayer(iCiv).isHuman() == 0):
                                                        self.killCiv(iCiv, iBarbarian)
                                        else:
                                                self.setNumCities(iCiv, lNumCitiesNew[iCiv])

        def collapseMotherland(self, iGameTurn):
                #collapses if completely out of broader areas
                for iCiv in range(iNumPlayers):
                        if (gc.getPlayer(iCiv).isHuman() == 0 and gc.getPlayer(iCiv).isAlive()):
                                if (iGameTurn >= con.tBirth[iCiv] + 25):
                                        bSafe = False
                                        for x in range(tBroaderAreasTL[iCiv][0], tBroaderAreasBR[iCiv][0]+1):
                                                for y in range(tBroaderAreasTL[iCiv][1], tBroaderAreasBR[iCiv][1]+1):
                                                        pCurrent = gc.getMap().plot( x, y )
                                                        if ( pCurrent.isCity()):
                                                                #print (pCurrent.getPlotCity().getOwner(), pCurrent.getPlotCity().getName(), pCurrent.getPlotCity().getX(), pCurrent.getPlotCity().getY())
                                                                if (pCurrent.getPlotCity().getOwner() == iCiv):
                                                                        #print ("iCiv", iCiv, "bSafe", bSafe)
                                                                        bSafe = True
                                                                        break
                                                                        break
                                        print ("iCiv", iCiv, "bSafe", bSafe)
                                        if (bSafe == False):
                                                self.killCiv(iCiv, iBarbarian)
                                                return
                        


        def collapseHuman(self, iOldOwner, city, iNewOwner):
                bEnabled = False
                bCapital = False
                bGeneric = False
                
                if (gc.getTeam(gc.getPlayer(iNewOwner).getTeam()).isHasTech(con.iCodeOfLaws)):
                        bEnabled = True
                                    
                iHuman = utils.getHumanID()
                if (city.getX() == tCapitals[iHuman][0] and city.getY() == tCapitals[iHuman][1]):
                        bCapital = True

                iNumCitiesNew = gc.getPlayer(iHuman).getNumCities()
                if (iNumCitiesNew*2 <= self.getNumCities(iHuman)):
                        print ("HumanCollapseGeneric", iNumCitiesNew*2, "<=", self.getNumCities(iHuman))
                        bGeneric = True

                #debug
                #bEnabled = True
                #bCapital = True
                
                if ((bCapital or bGeneric) and bEnabled):
                        self.exile(iNewOwner)


        def exile(self, iWinner):
                iHuman = utils.getHumanID()
                pWinner = gc.getPlayer(iWinner)
                teamWinner = gc.getTeam(pWinner.getTeam())
                iDestination = -1
                iRndnum = gc.getGame().getSorenRandNum(iNumPlayers, 'start index')
                for i in range( iRndnum, iNumPlayers + iRndnum ):
                        iCiv = i % iNumPlayers
                        if (gc.getPlayer(iCiv).isAlive()):
                                if (pWinner.canContact(iCiv)):
                                        if (not teamWinner.isAtWar(iCiv)):
                                                if (gc.getGame().getPlayerRank(iCiv) > gc.getGame().getPlayerRank(iHuman) + 1):
                                                        iDestination = iCiv
                                                        break                                          

                print (iDestination)
                popup = Popup.PyPopup()
                popup.setHeaderString(CyTranslator().getText("TXT_KEY_EXILE_TITLE", ()))          
                popup.setBodyString( CyTranslator().getText("TXT_KEY_EXILE_TEXT1", ()) + " " + gc.getPlayer(iWinner).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_EXILE_TEXT2", ()) + " " + gc.getPlayer(iDestination).getCivilizationShortDescription(0) + CyTranslator().getText("TXT_KEY_EXILE_TEXT3", ()))
                popup.launch()
                self.setExileData(0, gc.getPlayer(iHuman).getCapitalCity().getX())
                self.setExileData(1, gc.getPlayer(iHuman).getCapitalCity().getY())
                self.setExileData(2, gc.getGame().getGameTurn())
                self.setExileData(3, iHuman)
                self.setExileData(4, iWinner)
                gc.getGame().setActivePlayer(iDestination, False)
                teamWinner.makePeace(iHuman) #now managed by AI

                

        def escape(self, city):
                if (gc.getGame().getGameTurn() <= self.getExileData(2) + iEscapePeriod):
                        iOldHuman = self.getExileData(3)
                        if (gc.getPlayer(iOldHuman).isAlive()):
                                iHuman = utils.getHumanID()
                                utils.flipCity((city.getX(),city.getY()), 0, 0, iOldHuman, [iHuman])
                                popup = Popup.PyPopup()
                                popup.setHeaderString(CyTranslator().getText("TXT_KEY_ESCAPE_TITLE", ()))          
                                popup.setBodyString( CyTranslator().getText("TXT_KEY_ESCAPE_TEXT1", ()) + " " + gc.getPlayer(iOldHuman).getCivilizationAdjective(0) + " " + CyTranslator().getText("TXT_KEY_ESCAPE_TEXT2", ()))
                                popup.launch()
                                gc.getGame().setActivePlayer(iOldHuman, False)
                                city.setHasRealBuilding((0), True) #0 == palace
                                teamWinner = gc.getTeam(gc.getPlayer(self.getExileData(4)).getTeam())
                                teamWinner.declareWar(iOldHuman, True)
                                self.setExileData(0, -1)
                                self.setExileData(1, -1)
                                self.setExileData(2, -1)
                                self.setExileData(3, -1)
                                self.setExileData(4, -1)

                

        def killCiv(self, iCiv, iNewCiv):
                for pyCity in PyPlayer(iCiv).getCityList():
                        tCoords = (pyCity.GetCy().getX(), pyCity.GetCy().getY())
                        utils.cultureManager(tCoords, 50, iNewCiv, iCiv, False, False, False)
                        utils.flipCity(tCoords, 0, 0, iNewCiv, [iCiv]) #by trade because by conquest may raze the city
                utils.flipUnitsInArea([0,0], [123,67], iNewCiv, iCiv, False, True)



        def resurrection(self, iGameTurn):
                iHuman = utils.getHumanID()
                iRndnum1 = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                for i in range(iRndnum1, iRndnum1 + iNumPlayers):
                        iCiv = i % iNumPlayers
                        pCiv = gc.getPlayer(iCiv)
                        teamCiv = gc.getTeam(pCiv.getTeam())
                        if pCiv.isAlive():                                
                                if (teamCiv.isHasTech(con.iConstitution) or teamCiv.isHasTech(con.iLiberalism)):
                                #if (teamCiv.isHasTech(iPottery)): #debug
                                        iNumCities = len(PyPlayer(iCiv).getCityList())                                        
                                        if (iNumCities > 6):
                                        #if (iNumCities > 0): #debug
                                                iRndnum2 = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                                                for j in range(iRndnum2, iRndnum2 + iNumPlayers):
                                                        iDeadCiv = j % iNumPlayers
                                                        pDeadCiv = gc.getPlayer(iDeadCiv)
                                                        teamDeadCiv = gc.getTeam(pDeadCiv.getTeam())
                                                        if (not gc.getPlayer(iDeadCiv).isAlive() and iGameTurn > con.tBirth[iDeadCiv] + 50):
                                                                cityList = []
                                                                for x in range(tCoreAreasTL[iDeadCiv][0], tCoreAreasBR[iDeadCiv][0]+1):
                                                                        for y in range(tCoreAreasTL[iDeadCiv][1], tCoreAreasBR[iDeadCiv][1]+1):
                                                                                pCurrent = gc.getMap().plot( x, y )
                                                                                if ( pCurrent.isCity()):
                                                                                        city = pCurrent.getPlotCity()
                                                                                        if (city.getOwner() == iCiv):
                                                                                                if (not city.isNoUnhappiness()):
                                                                                                        if (not city.isNoUnhealthyPopulation()):
                                                                                                                if (not city.isWeLoveTheKingDay()):
                                                                                                                        cityList.append(pCurrent.getPlotCity())
                                                                if (iGameTurn - self.getLatestRebellionTurn(iDeadCiv) >= iRebellionDelay):
                                                                #if (iGameTurn > 0): #debug
                                                                        if (len(cityList) > 0):
                                                                                break
                                                                else:
                                                                        print ("rebellion delay left:", iGameTurn - self.getLatestRebellionTurn(iDeadCiv))
                                                if (len(cityList) > 0):
                                                        self.setRebelCiv(iDeadCiv) #for popup and CollapseCapitals()
                                                        print ("iCiv", iCiv, "iDeadCiv", iDeadCiv)
                                                        for l in range(iNumPlayers):
                                                                teamDeadCiv.makePeace(l)
                                                        self.setNumCities(iDeadCiv, 0) #reset collapse condition
                                                        iCountCities = 0
                                                        for t in range(con.iNumTechs):
                                                                if (teamCiv.isHasTech(t)):
                                                                        teamDeadCiv.setHasTech(t, True, iDeadCiv, False, False)
                                                        iNewUnits = 3
                                                        if (self.getLatestRebellionTurn(iDeadCiv) > 0):
                                                                iNewUnits = 4
                                                        for k in range(len(cityList)):
                                                                print (cityList[k].getName())
                                                                if (iCountCities < iNumCities/3): #otherwise, it collapses!
                                                                        utils.cultureManager((cityList[k].getX(),cityList[k].getY()), 50, iDeadCiv, iCiv, False, True, True)
                                                                        utils.pushOutGarrisons((cityList[k].getX(),cityList[k].getY()), iCiv)
                                                                        utils.relocateSeaGarrisons((cityList[k].getX(),cityList[k].getY()), iCiv)                                                                        
                                                                        self.setTempFlippingCity((cityList[k].getX(),cityList[k].getY()))
                                                                        utils.flipCity((cityList[k].getX(),cityList[k].getY()), 0, 0, iDeadCiv, [iCiv])   #by trade because by conquest may raze the city
                                                                        utils.createGarrisons(self.getTempFlippingCity(), iDeadCiv, iNewUnits)                                         
                                                                        iCountCities += 1
                                                        self.setLatestRebellionTurn(iDeadCiv, iGameTurn)
                                                        CyInterface().addImmediateMessage((CyTranslator().getText("TXT_KEY_INDEPENDENCE1", ()) + " " + \
                                                                                    pDeadCiv.getCivilizationAdjective(0) + " " + \
                                                                                    CyTranslator().getText("TXT_KEY_INDEPENDENCE2", ()) + " " + \
                                                                                    pCiv.getCivilizationDescription(0)) + "!" , "")                                                        
                                                        if (iCiv != iHuman):
                                                                if (pCiv.getCivics(1) == 9): #free speech (or 4?)
                                                                        teamCiv.makePeace(iDeadCiv)
                                                                else:
                                                                        teamCiv.declareWar(iDeadCiv, False)
                                                        else:
                                                               self.rebellionPopup(iDeadCiv)
                                                               
                                                        return
                              
        def resurrectionFromBarbs(self, iGameTurn):
                bEnabled = False
                for iCiv in range(iNumPlayers):
                        pCiv = gc.getPlayer(iCiv)
                        teamCiv = gc.getTeam(pCiv.getTeam())
                        if pCiv.isAlive():
                                if (teamCiv.isHasTech(con.iNationalism) or teamCiv.isHasTech(con.iGunpowder)):
                                        bEnabled = True
                                        break
                                #debug
                                #bEnabled = True
                                #break
                print ("bEnabled", bEnabled)
                if (bEnabled):
                        iNumCities = len(PyPlayer(iBarbarian).getCityList())
                        if (iNumCities > 10 ):                        
                        #if (iNumCities > 0 ):  #debug  
                                iRndnum2 = gc.getGame().getSorenRandNum(iNumPlayers, 'starting count')
                                cityList = []
                                for j in range(iRndnum2, iRndnum2 + iNumPlayers):
                                        iDeadCiv = j % iNumPlayers                                                        
                                        if (not gc.getPlayer(iDeadCiv).isAlive() and iGameTurn > con.tBirth[iDeadCiv] + 50):
                                                pDeadCiv = gc.getPlayer(iDeadCiv)
                                                teamDeadCiv = gc.getTeam(pDeadCiv.getTeam())
                                                cityList = []
                                                for x in range(tCoreAreasTL[iDeadCiv][0], tCoreAreasBR[iDeadCiv][0]+1):
                                                        for y in range(tCoreAreasTL[iDeadCiv][1], tCoreAreasBR[iDeadCiv][1]+1):
                                                                pCurrent = gc.getMap().plot( x, y )
                                                                if ( pCurrent.isCity()):
                                                                        if (pCurrent.getPlotCity().getOwner() == iBarbarian):
                                                                                cityList.append(pCurrent.getPlotCity())
                                                if (len(cityList) > 0):
                                                        break
                                if (len(cityList) > 0):
                                        print ("iBarbarian, iDeadCiv", iDeadCiv)
                                        self.setRebelCiv(iDeadCiv) #for popup and CollapseCapitals()
                                        self.setLatestRebellionTurn(iDeadCiv, iGameTurn)
                                        for l in range(iNumPlayers):
                                                teamDeadCiv.makePeace(l)
                                        self.setNumCities(iDeadCiv, 0) #reset collapse condition
                                        iCountCities = 0
                                        for t in range(con.iNumTechs):
                                                if (teamBarbarian.isHasTech(t)):
                                                        teamDeadCiv.setHasTech(t, True, iDeadCiv, False, False)
                                        for k in range(len(cityList)):
                                                print (cityList[k].getName())
                                                if (iCountCities < 5):
                                                        utils.cultureManager((cityList[k].getX(),cityList[k].getY()), 100, iDeadCiv, iBarbarian, False, True, True)
                                                        utils.flipUnitsInCityBefore((cityList[k].getX(),cityList[k].getY()), iDeadCiv, iBarbarian)
                                                        self.setTempFlippingCity((cityList[k].getX(),cityList[k].getY()))
                                                        utils.flipCity((cityList[k].getX(),cityList[k].getY()), 0, 0, iDeadCiv, [iBarbarian])
                                                        tCoords = self.getTempFlippingCity()
                                                        utils.flipUnitsInCityAfter(tCoords, iDeadCiv)
                                                        utils.flipUnitsInArea((tCoords[0]-2, tCoords[1]-2), (tCoords[0]+2, tCoords[1]+2), iDeadCiv, iBarbarian, True, False)
                                                        iCountCities += 1
                                        CyInterface().addImmediateMessage((CyTranslator().getText("TXT_KEY_INDEPENDENCE1", ()) + " " + \
                                                                    pDeadCiv.getCivilizationAdjective(0) + " " + \
                                                                    CyTranslator().getText("TXT_KEY_INDEPENDENCE2", ()) + " " + \
                                                                    pBarbarian.getCivilizationDescription(0)) + "!" , "")                                                        
                                        return
                                
                                    
        def initBirth(self, iCurrentTurn, iBirthYear, iCiv, strAdjective):
                iHuman = utils.getHumanID()
                tCapital = tCapitals[iCiv]
                tTopLeft = tCoreAreasTL[iCiv]
                tBottomRight = tCoreAreasBR[iCiv]
                tBroaderTopLeft = tBroaderAreasTL[iCiv]
                tBroaderBottomRight = tBroaderAreasBR[iCiv]
                if (iCurrentTurn == iBirthYear-1 + self.getSpawnDelay(iCiv) + self.getFlipsDelay(iCiv)):
                        if (self.getFlipsDelay(iCiv) == 0): #city hasn't already been founded)
                                bDeleteEverything = False
                                if (gc.getMap().plot(tCapital[0], tCapital[1]).isOwned()):
                                        if (iCiv == iHuman or not gc.getPlayer(iHuman).isAlive()):
                                                bDeleteEverything = True
                                                print ("bDeleteEverything 1")
                                        else:
                                                bDeleteEverything = True
                                                for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                                        for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                                                pCurrent=gc.getMap().plot(x, y)
                                                                if (pCurrent.isCity() or pCurrent.isVisible(iHuman, False)):
                                                                        bDeleteEverything = False
                                                                        print ("bDeleteEverything 2")
                                                                        break
                                                                        break
                                print ("bDeleteEverything", bDeleteEverything)
                                if (not gc.getMap().plot(tCapital[0], tCapital[1]).isOwned()):
                                        self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                elif (bDeleteEverything):
                                        for x in range(tCapital[0] - 1, tCapital[0] + 2):        # from x-1 to x+1
                                                for y in range(tCapital[1] - 1, tCapital[1] + 2):	# from y-1 to y+1
                                                        pCurrent=gc.getMap().plot(x, y)
                                                        pCurrent.eraseAIDevelopment() #new function, similar to erase but won't delete rivers, resources and features()
                                                        for iLoopCiv in range(iNumPlayers+1): #Barbarians as well
                                                                pCurrent.setCulture(iLoopCiv, 0, True)
                                                        pCurrent.setOwner(-1)
                                        self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                else:                                
                                        self.birthInForeignBorders(iCiv, tTopLeft, tBottomRight, tBroaderTopLeft, tBroaderBottomRight)
                        else:
                                print ( "setBirthType again: flips" )
                                self.birthInFreeRegion(iCiv, tCapital, tTopLeft, tBottomRight)
                                       
                if (iCurrentTurn == iBirthYear + self.getSpawnDelay(iCiv)) and (gc.getPlayer(iCiv).isAlive()) and (self.getAlreadySwitched() == False) and (iHuman+tDifference[iHuman] < iCiv):
                        self.newCivPopup(strAdjective, iCiv)   
            
                    
        def birthInFreeRegion(self, iCiv, tCapital, tTopLeft, tBottomRight):
                startingPlot = gc.getMap().plot( tCapital[0], tCapital[1] )
                if (self.getFlipsDelay(iCiv) == 0):
                        if (startingPlot.getNumUnits() > 0):
                                unit = startingPlot.getUnit(0)
                                if (unit.getOwner() != utils.getHumanID()):
                                        for i in range(startingPlot.getNumUnits()):
                                                unit = startingPlot.getUnit(0)	# 0 instead of i because killing units changes the indices
                                                unit.kill(False, iCiv)
                                        iFlipsDelay = self.getFlipsDelay(iCiv) + 2
                                        #utils.debugTextPopup( 'birthInFreeRegion in starting location' ) 
                                else:   #search another place
                                        dummy, plotList = utils.squareSearch( tTopLeft, tBottomRight, utils.goodPlots, [] )
                                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching another free plot')
                                        if (len(plotList)):
                                                result = plotList[rndNum]
                                                if (result):
                                                        self.createStartingUnits(iCiv, result)
                                                        tCapital = result
                                                        #utils.debugTextPopup( 'birthInFreeRegion in another location' )
                                                        iFlipsDelay = self.getFlipsDelay(iCiv) + 1 #add delay before flipping other cities
                                        else: 
                                                if (self.getSpawnDelay(iCiv) < 10):  #wait
                                                        iSpawnDelay = self.getSpawnDelay(iCiv) + 1
                                                        self.setSpawnDelay(iCiv, iSpawnDelay)                                                        
                        else:
                                iFlipsDelay = self.getFlipsDelay(iCiv) + 2

                        if (iFlipsDelay > 0):
                                #startingPlot.setImprovementType(-1)
                            
                                #gc.getPlayer(iCiv).found(tCapital[0], tCapital[1])
                                #gc.getMap().plot(tCapital[0], tCapital[1]).setRevealed(iCiv, False, True, -1);
                                #gc.getMap().plot(tCapital[0], tCapital[1]).setRevealed(iCiv, True, True, -1);
                                
                                
                                self.createStartingUnits(iCiv, (tCapital[0], tCapital[1]))##                                settlerPlot = gc.getMap().plot( tCapital[0], tCapital[1] )
##                                for i in range(settlerPlot.getNumUnits()):
##                                        unit = settlerPlot.getUnit(i)
##                                        if (unit.getUnitType() == iSettler):
##                                                break
##                                unit.found()                                
                                utils.flipUnitsInArea((tCapital[0]-2, tCapital[1]-2), (tCapital[0]+2, tCapital[1]+2), iCiv, iBarbarian, True, False) #This is for AI only. During Human player spawn, that area is already cleaned                        
                                self.assignTechs(iCiv)
                                #gc.getPlayer(iCiv).changeAnarchyTurns(1)
                                #gc.getPlayer(iCiv).setCivics(2, 11)
                                self.setFlipsDelay(iCiv, iFlipsDelay) #save
                                

                else: #starting units have already been placed, now the second part                    
                        iNumConverted = self.convertSurroundingCities(iCiv, tTopLeft, tBottomRight)
                        print ("iNumConverted", iNumConverted) 
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, False, False) #remaining barbs in the region now belong to the new civ   
                        print ("utils.flipUnitsInArea()") 
                        #cover plots revealed by the lion
                        plotZero = gc.getMap().plot( 0, 0 )                        
                        if (plotZero.getNumUnits()):
                                catapult = plotZero.getUnit(0)
                                catapult.kill(False, iCiv)
                        gc.getMap().plot(0, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(0, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(2, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(1, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(0, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 0).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 1).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(122, 2).setRevealed(iCiv, False, True, -1);
                        gc.getMap().plot(123, 2).setRevealed(iCiv, False, True, -1);
                        print ("Plots covered") 



                        
        def birthInForeignBorders(self, iCiv, tTopLeft, tBottomRight, tBroaderTopLeft, tBroaderBottomRight):
                
                iConvertedCities = self.convertSurroundingCities(iCiv, tTopLeft, tBottomRight)

                #now starting units must be placed
                if (iConvertedCities > 0):
                        #utils.debugTextPopup( 'iConverted OK for placing units' )
                        dummy1, plotList = utils.squareSearch( tTopLeft, tBottomRight, utils.ownedCityPlots, iCiv )        
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching any city just flipped')
                        #print ("rndNum for starting units", rndNum)
                        if (len(plotList)):
                                result = plotList[rndNum]
                                if (result):
                                        self.createStartingUnits(iCiv, result)
                                        #utils.debugTextPopup( 'birthInForeignBorders after a flip' )
                                        self.assignTechs(iCiv)
                                        #gc.getPlayer(iCiv).changeAnarchyTurns(1)
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, False, False) #remaining barbs in the region now belong to the new civ 
                        
                else:
                        #utils.debugTextPopup( 'iConverted check for placing units failed' )
                        dummy1, plotList = utils.squareSearch( tBroaderTopLeft, tBroaderBottomRight, utils.goodPlots, [] )        
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching other good plots in a broader region')
                        if (len(plotList)):
                                result = plotList[rndNum]
                                if (result):
                                        self.createStartingUnits(iCiv, result)
                                        #utils.debugTextPopup( 'birthInForeignBorders in a broader area' )
                                        self.assignTechs(iCiv)
                        utils.flipUnitsInArea(tTopLeft, tBottomRight, iCiv, iBarbarian, True, False) #remaining barbs in the region now belong to the new civ 

                                                
        def convertSurroundingCities(self, iCiv, tTopLeft, tBottomRight):
                iConvertedCitiesCount = 0
                iNumHumanCities = 0
                cityList = []
                self.setSpawnWar(0)
                
                #collect all the cities in the spawn region
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() != iCiv):
                                                cityList.append(pCurrent.getPlotCity())

                #Exceptions
                if (len(tExceptions[iCiv])):
                        for j in range(len(tExceptions[iCiv])):
                                pCurrent = gc.getMap().plot( tExceptions[iCiv][j][0], tExceptions[iCiv][j][1] )
                                if ( pCurrent.isCity()):
                                        if (pCurrent.getPlotCity().getOwner() != iCiv):
                                                print ("append", pCurrent)
                                                cityList.append(pCurrent.getPlotCity())

                print ("Birth", iCiv)
                #print (cityList)

                #for each city
                if (len(cityList)):
                        for i in range(len(cityList)):
                                print ("cityList", cityList[i].getName(), (cityList[i].getX(),cityList[i].getY()))
                                iHuman = utils.getHumanID()
                                iOwner = cityList[i].getOwner()
                                iCultureChange = 0 #if 0, no flip; if > 0, flip will occur with the value as variable for utils.CultureManager()
                                
                                if (not cityList[i].isCapital()):
                                        #case 1: barbarian city
                                        if (iOwner == iBarbarian):
                                                #utils.debugTextPopup( 'BARB' )
                                                iCultureChange = 100
                                        #case 2: human city
                                        elif (iOwner == iHuman):
                                                #utils.debugTextPopup( 'HUMAN' )
                ##                                bForeigners = False
                ##                                cityPlot = gc.getMap().plot(cityList[i].getX(), cityList[i].getY())
                ##                                cityCulture = cityList[i].countTotalCulture()
                ##                                iCultureThreshold = 10
                ##                                for j in range(iNumPlayers+1):
                ##                                        if (cityList[i].getCulture(j)*100 / cityCulture >= iCultureThreshold) and (j != iHuman):
                ##                                                bForeigners = True
                ##                                humanCapital = gc.getPlayer(iHuman).getCapitalCity()
                ##                                iDistance = gc.getMap().calculatePathDistance(cityPlot, gc.getMap().plot(humanCapital.getX(),humanCapital.getY()))
                ##                                if (cityList[i].isOccupation()) or (cityList[i].isDisorder()) or (bForeigners == True) or (not cityPlot.getNumUnits()) or ((not cityList[i].isGovernmentCenter()) and (iDistance >= 8) and (gc.getPlayer(iHuman).getNumCities() >= 5)):
                                                if (iNumHumanCities == 0):
                                                        iNumHumanCities += 1
                                                        iConvertedCitiesCount += 1
                                                        self.flipPopup(iCiv, tTopLeft, tBottomRight)
                                        #case 3: other
                                        else:   #utils.debugTextPopup( 'OTHER' )                                
                                                if (iConvertedCitiesCount < 6): #there won't be more than 5 flips in the area
                                                        #utils.debugTextPopup( 'iConvertedCities OK' )
                                                        iCultureChange = 50
                                                        if (gc.getGame().getGameTurn() <= con.tBirth[iCiv] + 5): #if we're during a birth
                                                                rndNum = gc.getGame().getSorenRandNum(100, 'odds')
                                                                if (rndNum >= tAIStopBirthThreshold[iOwner]):
                                                                        print (iOwner, "stops birth", iCiv, "rndNum:", rndNum, "threshold:", tAIStopBirthThreshold[iOwner])
                                                                        if (not gc.getTeam(gc.getPlayer(iOwner).getTeam()).isAtWar(iCiv)):                                                                        
                                                                                gc.getTeam(gc.getPlayer(iOwner).getTeam()).declareWar(iCiv, False)
                                                                                self.createAdditionalUnits(iCiv, (gc.getPlayer(iCiv).getCapitalCity().getX(), gc.getPlayer(iCiv).getCapitalCity().getY()))
                                                                        
                                                                

                                        if (iCultureChange > 0):
                                                #print ("flipping ", cityList[i].getName())
                                                utils.cultureManager((cityList[i].getX(),cityList[i].getY()), iCultureChange, iCiv, iOwner, True, False, False)
                                                #gc.getMap().plot(cityList[i].getX(),cityList[i].getY()).setImprovementType(-1)
                                                
                                                utils.flipUnitsInCityBefore((cityList[i].getX(),cityList[i].getY()), iCiv, iOwner)
                                                self.setTempFlippingCity((cityList[i].getX(),cityList[i].getY())) #necessary for the (688379128, 0) bug
                                                utils.flipCity((cityList[i].getX(),cityList[i].getY()), 0, 0, iCiv, [iOwner])                                                
                                                #print ("cityList[i].getXY", cityList[i].getX(), cityList[i].getY()) 
                                                utils.flipUnitsInCityAfter(self.getTempFlippingCity(), iCiv)
                                                
                                                iConvertedCitiesCount += 1
                                                print ("iConvertedCitiesCount", iConvertedCitiesCount)

                #print( "converted cities", iConvertedCitiesCount)
                return iConvertedCitiesCount

            

        def findSeaPlots( self, tCoords):
                """Searches a sea plot that isn't occupied by a unit and isn't a civ's territory surrounding the starting coordinates"""
                seaPlotList = []
                for x in range(tCoords[0] - 1, tCoords[0] + 2):        # from x-1 to x+1
                        for y in range(tCoords[1] - 1, tCoords[1] + 2):	# from y-1 to y+1
                                pCurrent = gc.getMap().plot( x, y )
                                if ( pCurrent.isWater()):
                                        if ( not pCurrent.isUnit() ):
                                                if (pCurrent.countTotalCulture() == 0 ):
                                                        seaPlotList.append(pCurrent)
                                                        # this is a good plot, so paint it and continue search
                if (len(seaPlotList) > 0):
                        rndNum = gc.getGame().getSorenRandNum(len(seaPlotList), 'sea plot')
                        result = seaPlotList[rndNum]
                        if (result):                                                        
                                    return ((result.getX(), result.getY()))
                return (None)


        def giveColonists( self, iCiv, tBroaderAreaTL, tBroaderAreaBR):
                pCiv = gc.getPlayer(iCiv)
                teamCiv = gc.getTeam(pCiv.getTeam())
                if (teamCiv.isHasTech(con.iAstronomy)) and (self.getColonistsAlreadyGiven(iCiv) <= 5) and (pCiv.isAlive()) and (pCiv.isHuman() == False):
                        print ("Astronomy")
                        cityList = []
                        #collect all the coastal cities belonging to iCiv in the area
                        for x in range(tBroaderAreaTL[0], tBroaderAreaBR[0]+1):
                                for y in range(tBroaderAreaTL[1], tBroaderAreaBR[1]+1):
                                        pCurrent = gc.getMap().plot( x, y )
                                        if ( pCurrent.isCity()):
                                                city = pCurrent.getPlotCity()
                                                if (city.getOwner() == iCiv):
                                                        if (city.isCoastal()):
                                                                cityList.append(city)                                                        
                        if (len(cityList)):
                                rndNum = gc.getGame().getSorenRandNum(len(cityList), 'random city')
                                result = cityList[rndNum]
                                if (result):
                                        tPlot = (result.getX(), result.getY())
                                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                                        if (rndNum % 2 == 0):
                                                utils.makeUnit(con.iPikeman, iCiv, tPlot, 1)
                                        else:
                                                utils.makeUnit(con.iWorker, iCiv, tPlot, 1)
                                        if (teamCiv.isHasTech(con.iGunpowder)):
                                                utils.makeUnit(con.iMusketman, iCiv, tPlot, 1)
                                        else:
                                                utils.makeUnit(con.iLongbowman, iCiv, tPlot, 1)
                                        gc.getPlayer(iCiv).initUnit(con.iGalleon, tPlot[0], tPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)
                                        iColonistsAlreadyGiven = self.getColonistsAlreadyGiven(iCiv) + 1
                                        self.setColonistsAlreadyGiven(iCiv, iColonistsAlreadyGiven)
                                        print iCiv

                #part2: upgrade galleys to galleons, just once
                if (gc.getTeam(pCiv.getTeam()).isHasTech(con.iAstronomy)) and (self.getColonistsAlreadyGiven(iCiv) == 0) and (pCiv.isAlive()) and (pCiv.isHuman() == False):
                        for x in range(0, 123+1):
                                for y in range(0, 67+1):
                                        killPlot = gc.getMap().plot(x,y)
                                        iNumUnitsInAPlot = killPlot.getNumUnits()
                                        if (iNumUnitsInAPlot):  
                                                for i in range(iNumUnitsInAPlot):                                                
                                                        unit = killPlot.getUnit(i)
                                                        if (unit.getOwner() == iCiv):
                                                                if (unit.getUnitType() == iGalley):
                                                                        unit.kill(False, iBarbarian)
                                                                        gc.getPlayer(iCiv).initUnit(iGalleon, x, y, UnitAITypes.UNITAI_SETTLER_SEA)
                                                                        i = i - 1
                          


        def initMinorBetrayal( self, iCiv ):
                iHuman = utils.getHumanID()
                dummy, plotList = utils.squareSearch( tCoreAreasTL[iCiv], tCoreAreasBR[iCiv], utils.outerInvasion, [] )
                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot abroad human players borders')
                if (len(plotList)):
                        result = plotList[rndNum]
                        if (result):
                                self.createAdditionalUnits(iCiv, result)
                                self.unitsBetrayal(iCiv, iHuman, tCoreAreasTL[iCiv], tCoreAreasBR[iCiv], result)



        def initBetrayal( self ):
                iHuman = utils.getHumanID()
                turnsLeft = self.getBetrayalTurns()
                dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.outerInvasion, [] )
                rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot abroad human players borders')
                if (not len(plotList)):
                        dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.innerInvasion, [iHuman, self.getNewCivFlip()] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot within human or new civs border but distant from units')                                
                if (not len(plotList)):
                        dummy, plotList = utils.squareSearch( self.getTempTopLeft(), self.getTempBottomRight(), utils.innerInvasion, [iHuman, self.getNewCivFlip()] )
                        rndNum = gc.getGame().getSorenRandNum(len(plotList), 'searching a free plot within human or new civs border')                                
                if (len(plotList)):
                        result = plotList[rndNum]
                        if (result):
                                if (turnsLeft == iBetrayalPeriod):
                                        self.createAdditionalUnits(self.getNewCivFlip(), result)
                                self.unitsBetrayal(self.getNewCivFlip(), iHuman, self.getTempTopLeft(), self.getTempBottomRight(), result)
                self.setBetrayalTurns(turnsLeft - 1)



        def unitsBetrayal( self, iNewOwner, iOldOwner, tTopLeft, tBottomRight, tPlot ):
                print ("iNewOwner", iNewOwner, "iOldOwner", iOldOwner, "tPlot", tPlot)
                CyInterface().addImmediateMessage(CyTranslator().getText("TXT_KEY_FLIP_BETRAYAL", ()), "")
                for x in range(tTopLeft[0], tBottomRight[0]+1):
                        for y in range(tTopLeft[1], tBottomRight[1]+1):
                                killPlot = gc.getMap().plot(x,y)
                                iNumUnitsInAPlot = killPlot.getNumUnits()
                                if (iNumUnitsInAPlot):                                                                  
                                        for i in range(iNumUnitsInAPlot):                                                
                                                unit = killPlot.getUnit(i)
                                                if (unit.getOwner() == iOldOwner):
                                                        rndNum = gc.getGame().getSorenRandNum(100, 'betrayal')
                                                        if (rndNum >= iBetrayalThreshold):
                                                                if (unit.getDomainType() == 2): #land unit
                                                                        unit.kill(False, iNewOwner)
                                                                        utils.makeUnit(unit.getUnitType(), iNewOwner, tPlot, 1)
                                                                        i = i - 1



        def createAdditionalUnits( self, iCiv, tPlot ):
                if (iCiv == iGreece):
                        utils.makeUnit(con.iSpearman_Phalanx, iCiv, tPlot, 4)
                if (iCiv == iPersia):
                        utils.makeUnit(con.iImmortal, iCiv, tPlot, 4)
                if (iCiv == iRome):
                        utils.makeUnit(con.iPraetorian, iCiv, tPlot, 4)
                if (iCiv == iJapan):
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                if (iCiv == iArabia):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iCamelArcher, iCiv, tPlot, 4)
                if (iCiv == iFrance):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iSpain):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iEngland):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iGermany):                        
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iRussia):
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2)                 
                if (iCiv == iMali):
                        utils.makeUnit(con.iSkirmisher, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 3)
                if (iCiv == iInca):
                        utils.makeUnit(con.iQuechua, iCiv, tPlot, 5)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                if (iCiv == iMongolia):
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2) 
                        utils.makeUnit(con.iKeshik, iCiv, tPlot, 4)
                if (iCiv == iAztecs):
                        utils.makeUnit(con.iJaguar, iCiv, tPlot, 5)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                if (iCiv == iAmerica):
                        utils.makeUnit(con.iPikeman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iMusketman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iCannon, iCiv, tPlot, 4)



        def createStartingUnits( self, iCiv, tPlot ):
                if (iCiv == iGreece):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                        utils.makeUnit(con.iWarrior, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSpearman_Phalanx, iCiv, tPlot, 3)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 1)
                if (iCiv == iPersia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 2)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 5)
                        utils.makeUnit(con.iImmortal, iCiv, tPlot, 7)
                if (iCiv == iRome):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 1)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 3)
                        utils.makeUnit(con.iPraetorian, iCiv, tPlot, 4)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 1)
                                pRome.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                                pRome.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_ASSAULT_SEA)
                if (iCiv == iJapan):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 2)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 2)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                if (iCiv == iArabia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iCamelArcher, iCiv, tPlot, 5)
                if (iCiv == iFrance):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 2)
                if (iCiv == iSpain):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 4)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                if (iCiv == iEngland):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 5)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):                                
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iGalley, iCiv, tSeaPlot, 2)
                                pEngland.initUnit(con.iGalley, tSeaPlot[0], tSeaPlot[1], UnitAITypes.UNITAI_SETTLER_SEA)
                if (iCiv == iGermany):                        
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 1)
                        utils.makeUnit(con.iAxeman, iCiv, tPlot, 3)
                if (iCiv == iRussia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iLongbowman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iSwordsman, iCiv, tPlot, 2)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 3)                 
                if (iCiv == iMali):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 3)
                        utils.makeUnit(con.iSkirmisher, iCiv, tPlot, 7)   
                if (iCiv == iInca):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 4)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 7)
                        utils.makeUnit(con.iScout, iCiv, tPlot, 2)
                        utils.makeUnit(con.iQuechua, iCiv, tPlot, 6)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 5)
                if (iCiv == iMongolia):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 5)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iCrossbowman, iCiv, tPlot, 3)
                        utils.makeUnit(con.iHorseArcher, iCiv, tPlot, 2) 
                        utils.makeUnit(con.iKeshik, iCiv, tPlot, 7)
                if (iCiv == iAztecs):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 3)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 4)
                        utils.makeUnit(con.iJaguar, iCiv, tPlot, 6)
                        utils.makeUnit(con.iArcher, iCiv, tPlot, 6)
                if (iCiv == iAmerica):
                        utils.makeUnit(con.iSettler, iCiv, tPlot, 5)
                        utils.makeUnit(con.iWorker, iCiv, tPlot, 8)
                        utils.makeUnit(con.iGrenadier, iCiv, tPlot, 2)
                        utils.makeUnit(con.iRifleman, iCiv, tPlot, 6)
                        utils.makeUnit(con.iCannon, iCiv, tPlot, 2)
                        tSeaPlot = self.findSeaPlots(tPlot)
                        if (tSeaPlot):  
                                utils.makeUnit(con.iWorkBoat, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iGalleon, iCiv, tSeaPlot, 2)
                                utils.makeUnit(con.iFrigate, iCiv, tSeaPlot, 2)


                        

        def create4000BCstartingUnits( self ):

                utils.makeUnit(iSettler, iEgypt, tCapitals[iEgypt], 1)
                utils.makeUnit(iWarrior, iEgypt, tCapitals[iEgypt], 1)

                utils.makeUnit(iSettler, iIndia, tCapitals[iIndia], 1)
                utils.makeUnit(iWarrior, iIndia, tCapitals[iIndia], 1)

                utils.makeUnit(iSettler, iChina, tCapitals[iChina], 1)
                utils.makeUnit(iWarrior, iChina, tCapitals[iChina], 1)

                if ( pGreece.isHuman() ):
                    utils.makeUnit(iSettler, iGreece, tCapitals[iGreece], 1)
                    utils.makeUnit(iScout, iGreece, tCapitals[iGreece], 1)
                if ( pPersia.isHuman() ):
                    utils.makeUnit(iSettler, iPersia, tCapitals[iPersia], 1)
                    utils.makeUnit(iScout, iPersia, tCapitals[iPersia], 1)
                if ( pRome.isHuman() ):
                    utils.makeUnit(iSettler, iRome, tCapitals[iRome], 1)
                    utils.makeUnit(iWarrior, iRome, tCapitals[iRome], 1)
                if ( pJapan.isHuman() ):
                    utils.makeUnit(iSettler, iJapan, tCapitals[iJapan], 1)
                    utils.makeUnit(iWarrior, iJapan, tCapitals[iJapan], 1)
                if ( pFrance.isHuman() ):
                    utils.makeUnit(iSettler, iFrance, tCapitals[iFrance], 1)
                    utils.makeUnit(iWarrior, iFrance, tCapitals[iFrance], 1)
                if ( pArabia.isHuman() ):
                    utils.makeUnit(con.iSettler, iArabia, tCapitals[iArabia], 1)
                    utils.makeUnit(con.iWarrior, iArabia, tCapitals[iArabia], 1)
                if ( pSpain.isHuman() ):
                    utils.makeUnit(iSettler, iSpain, tCapitals[iSpain], 1)
                    utils.makeUnit(iWarrior, iSpain, tCapitals[iSpain], 1)
                if ( pEngland.isHuman() ):
                    utils.makeUnit(iSettler, iEngland, tCapitals[iEngland], 1)
                    utils.makeUnit(iWarrior, iEngland, tCapitals[iEngland], 1)
                if ( pGermany.isHuman() ):
                    utils.makeUnit(iSettler, iGermany, tCapitals[iGermany], 1)
                    utils.makeUnit(iScout, iGermany, tCapitals[iGermany], 1)
                if ( pRussia.isHuman() ):
                    utils.makeUnit(iSettler, iRussia, tCapitals[iRussia], 1)
                    utils.makeUnit(iScout, iRussia, tCapitals[iRussia], 1)
                if ( pMali.isHuman() ):
                    utils.makeUnit(iSettler, iMali, tCapitals[iMali], 1)
                    utils.makeUnit(iWarrior, iMali, tCapitals[iMali], 1)
                if ( pInca.isHuman() ):
                    utils.makeUnit(iSettler, iInca, tCapitals[iInca], 1)
                    utils.makeUnit(iWarrior, iInca, tCapitals[iInca], 1)
                if ( pMongolia.isHuman() ):
                    utils.makeUnit(iSettler, iMongolia, tCapitals[iMongolia], 1)
                    utils.makeUnit(iScout, iMongolia, tCapitals[iMongolia], 1)
                if ( pAztecs.isHuman() ):
                    utils.makeUnit(iSettler, iAztecs, tCapitals[iAztecs], 1)
                    utils.makeUnit(iScout, iAztecs, tCapitals[iAztecs], 1)
                if ( pAmerica.isHuman() ):
                    utils.makeUnit(iSettler, iAmerica, tCapitals[iAmerica], 1)
                    utils.makeUnit(iWarrior, iAmerica, tCapitals[iAmerica], 1)


        def assignTechs( self, iCiv ):
                #popup = Popup.PyPopup()
                #popup.setBodyString( 'assigning techs to civ #%d' %(iCiv))
                #popup.launch()            
                if (iCiv == iGreece):
                        teamGreece.setHasTech(con.iMining, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iWriting, True, iCiv, False, False)
                        #teamGreece.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        #teamGreece.setHasTech(con.iLiterature, True, iCiv, False, False)
                        teamGreece.setHasTech(con.iHunting, True, iCiv, False, False)
                if (iCiv == iPersia):
                        teamPersia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        #teamPersia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamPersia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iRome):
                        teamRome.setHasTech(con.iMining, True, iCiv, False, False)
                        teamRome.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamRome.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamRome.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamRome.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamRome.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamRome.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamRome.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamRome.setHasTech(con.iWriting, True, iCiv, False, False)
                        #teamRome.setHasTech(con.iCodeOfLaws, True, iCiv, False, False) founds Confucianism
                        teamRome.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamRome.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamRome.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                if (iCiv == iJapan):
                        teamJapan.setHasTech(con.iMining, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMeditation, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamJapan.setHasTech(con.iWriting, True, iCiv, False, False)
                if (iCiv == iArabia):
                        teamArabia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iDivineRight, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iGuilds, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamArabia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iSpain):
                        teamSpain.setHasTech(con.iMining, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamSpain.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iFrance):
                        teamFrance.setHasTech(con.iMining, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMysticism, True, iCiv, False, False)                        
                        teamFrance.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamFrance.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iEngland):
                        teamEngland.setHasTech(con.iMining, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iSailing, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamEngland.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iGermany):
                        teamGermany.setHasTech(con.iMining, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamGermany.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iRussia):
                        teamRussia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamRussia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iMali):
                        teamMali.setHasTech(con.iMining, True, iCiv, False, False)
                        teamMali.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamMali.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMonotheism, True, iCiv, False, False)
                        teamMali.setHasTech(con.iTheology, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamMali.setHasTech(con.iDivineRight, True, iCiv, False, False)
                        teamMali.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamMali.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamMali.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAlphabet, True, iCiv, False, False)
                        teamMali.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamMali.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamMali.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamMali.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamMali.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamMali.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamMali.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)
                if (iCiv == iInca):
                        teamInca.setHasTech(con.iMining, True, iCiv, False, False)
                        #teamInca.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamInca.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamInca.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamInca.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamInca.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamInca.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamInca.setHasTech(con.iMathematics, True, iCiv, False, False)
                        #teamInca.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamInca.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamInca.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamInca.setHasTech(con.iArchery, True, iCiv, False, False)
                if (iCiv == iMongolia):
                        teamMongolia.setHasTech(con.iMining, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMachinery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMeditation, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iFeudalism, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iGuilds, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iArchery, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iAnimalHusbandry, True, iCiv, False, False)
                        teamMongolia.setHasTech(con.iHorsebackRiding, True, iCiv, False, False)                      
                if (iCiv == iAztecs):
                        teamAztecs.setHasTech(con.iMining, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iBronzeWorking, True, iCiv, False, False)
                        #teamAztecs.setHasTech(con.iIronWorking, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMetalCasting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMysticism, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPolytheism, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMasonry, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPriesthood, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMonarchy, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iFishing, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iTheWheel, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iPottery, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iAgriculture, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iWriting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCodeOfLaws, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iMathematics, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCalendar, True, iCiv, False, False)
                        #teamAztecs.setHasTech(con.iConstruction, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iCurrency, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iHunting, True, iCiv, False, False)
                        teamAztecs.setHasTech(con.iArchery, True, iCiv, False, False)
                if (iCiv == iAmerica):
                        for x in range(con.iLiberalism+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)
                        for x in range(con.iFishing, con.iChemistry+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)
                        for x in range(con.iHunting, con.iRifling+1):
                                teamAmerica.setHasTech(x, True, iCiv, False, False)





                        




